import sys

from gi.repository import Gtk
from gi.repository import GwibberGtk
 
class GwibberEntry:
    def __init__(self):
        window = Gtk.Window()
        window.set_title("Gwibber Poster")
        window.set_icon_name("gwibber")
        window.set_position (Gtk.WindowPosition.CENTER)
        window.resize(400, 150)
        self.entry = GwibberGtk.Entry()
        self.entry.set_margin_left (5)
        self.entry.set_margin_right (5)
        self.entry.set_margin_bottom (5)
        self.entry.set_margin_top (5)
        window.add(self.entry)
        window.show_all()
        window.present()
        window.connect("destroy", self.on_close)
 
    def on_close(self, w):
        Gtk.main_quit()
      
    def set_text(self, t):
        self.entry.text_view.get_buffer().set_text (t)

class UploadImage():
	"""
	Upload images to imgur
	"""

	# Not very verbose at the moment in terms of errors - will build on that later
	def __init__(self,image,upload_method="anon"):
		import pycurl
		from xml.dom import minidom
		import cStringIO

		# setup some initial items we will need
		self.c = pycurl.Curl()
		self.response = cStringIO.StringIO()
		self.minidom = minidom
		self.image = image
		self.imageURL = ""
		self.error = ""

		# provide some various methods for uploading
		# by default - at least for now in testing - we will use anonymous upload method
		if upload_method == "anon":
			self.anon_upload()
		# later or on-demand we can switch to oauth based uploads
		elif upload_method == "oauth":
			self.auth_upload()

	# anonymous upload method
	def anon_upload(self):
		"Upload anonymously to imgur"

		# setup the basic parameters
		params = [
				("key", "a56273e061bff4cea4a27434416fe55a"),
				("image", (self.c.FORM_FILE, self.image))
			]

		# setup the url and pipe in our key and image
		self.c.setopt(self.c.URL, "http://api.imgur.com/2/upload.xml")
		self.c.setopt(self.c.HTTPPOST, params)

		# we want to capture the output so lets set the write output to go to our cStringIO so we can parse it
		self.c.setopt(self.c.WRITEFUNCTION, self.response.write)

		# run it
		self.c.perform()
		self.c.close()

		try:
			# parse the XML return string and get the URL of our image
			xml = self.minidom.parseString(self.response.getvalue())
			self.imageURL = xml.getElementsByTagName("original")[0].firstChild.data

		except:
			self.error = "Problem uploading anonymously."

		return self.imageURL,self.error

	# oauth-based upload method
	def oauth_upload(self):
		"Upload using oauth to imgur"

		### Not coded yet but we will use python-oauth2
		pass
	
a = UploadImage (sys.argv[1])

ge = GwibberEntry()
ge.set_text (a.imageURL)

Gtk.main()